// TermHire.cpp
// v0.94
// this code come from the setfile add-on, "slightly" modified

#include <Directory.h>
#include <Window.h>
#include <StringView.h>
#include <File.h>
#include <Alert.h>
#include <Message.h>
#include <Debug.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

// use this define if you want little windows to explain you what's going on
//#define VERBOSE 1
#define PATH_LENGTH 2049


// global variables. I know it is ugly, but this is just an add-on

char *argv[3] = { "//apps/Terminal" ,NULL,NULL}; // the app which is launched
int numOK = 0; // number of Terminals launched correctly
extern char **environ; // this is the global context of the shell

#ifdef VERBOSE
BWindow *win;
BStringView *status;
#endif


#pragma export on
void process_refs(record_ref dir_ref, BMessage* msg, void*);
#pragma export reset
int LaunchTerminal(char *path);
char **new_environ(char **orig, char *new_var);

static void error(const char *message)
{
	BAlert *alert = new BAlert("TermHire Error", message, "OK");
	alert->Go();
}

char **new_environ(char **orig, char *new_var)
{
	int nb_lines=0,i;
	char **dest;
	
	while(orig[nb_lines]!=NULL) nb_lines++;
	dest=(char **)malloc((nb_lines+2)*sizeof(char **));
	
	// we just need to copy the pointers, since there will be another copy
	// when the app will be launched(I'm not really sure of that though)
	for(i=0;i<nb_lines;i++)
		dest[i]=orig[i];
		
	// now the new one is allocated	
	dest[nb_lines]=(char *)malloc(strlen(new_var)+1);
	strcpy(dest[nb_lines],new_var);
	dest[nb_lines+1]=NULL;
	
	return dest;
}


int LaunchTerminal(char *path)
{
	char **environ2,path2[PATH_LENGTH];

	// now, it formats the new environment context,
	// containing the variable FOLDER_PATH
	path2[0]='\0';
	strcat(path2,"FOLDER_PATH=");
	strcat(path2,path);
	environ2=new_environ(environ,path2);

	// the info window stuff
#ifdef VERBOSE
	win->Lock();
	status->SetText(path);
	win->Unlock();
#endif

	thread_id tid = load_posix(argv[0], argv, environ2);
	if (tid > 0)
	{
		resume_thread(tid);
		numOK++;
		return 1;
	}
	else 
	{
		sprintf(path, "Error %08x running %s", tid, argv[0]);
		error(path);
		return B_ERROR;
	}
}

void process_refs(record_ref dir_ref, BMessage* msg, void*)
{
	long count; // number of references stored in the BMessage
	ulong type;
	char path[PATH_LENGTH+1]; // path to use to launch the terminal

// this creates an informative window about the completion of the add-on
#ifdef VERBOSE
	BRect area(0,0, 250,15);
	screen_info info;

	get_screen_info(&info);
	area.OffsetBy(info.frame.Width()/2-125, info.frame.Height()/2-10);
	win = new BWindow(area, "TermHire Progress", B_TITLED_WINDOW,
		B_NOT_ZOOMABLE | B_NOT_RESIZABLE | B_NOT_CLOSABLE);
	status = new BStringView(win->Bounds(), "status", "TermHire");
	win->AddChild(status);
	win->Show();
#endif


	// first, we consider the case when the add-on has been selected
	// from the file menu of the browser window or by right-clicking
	// in the background of the window
	// i.e : in this case, there is no refs on the BMessage
	
	if (!msg->GetInfo("refs", &type, &count))
	{
		BDirectory directory(dir_ref);
		directory.GetPath(path,PATH_LENGTH);
		if(!LaunchTerminal(path)) goto exit;
	}
	else
	{
		// if there are datas on the BMessage, but not from the ref type, exit...
		if (type != B_REF_TYPE) 
		{
			error("Cannot handle selection!");
			return;
		}
		else
		for (int ix=0; ix<count; ix++) 
		{
			record_ref ref = msg->FindRef("refs", ix);
			// if the ref is a folder, launch a Terminal on this folder
			if(does_ref_conform(ref,"Folder"))
			{
				BDirectory directory(ref);
				directory.GetPath(path,2048);
				if(!LaunchTerminal(path)) goto exit;
			}
			// if the ref is a file, launch a Terminal on the parent folder
			else if(does_ref_conform(ref,"File")) 
			{
				BDirectory *directory=new BDirectory();
				BFile file(ref);
	
				// I ask for the parent directory of the file
				file.GetParent(directory);
				directory->GetPath(path,2048);
				if(!LaunchTerminal(path)) goto exit;
				delete(directory);
			}
		}
	}
	
#ifdef VERBOSE
	sprintf(path, "%d out of %d were set", numOK, count);
	win->Lock();
	status->SetText(path);
	win->Unlock();
#endif
exit:
#ifdef VERBOSE
	snooze(100000);
	win->Quit();
#endif
	;
}

